(*** OPENS ********************************************************************)

(*** MODULES ******************************************************************)

(*** TYPES ********************************************************************)
type 'a idx = {
 itbl : ('a,int) Hashtbl.t;
 vtbl : (int,'a) Hashtbl.t;
 idx  : int ref;
}
(*** FUNCTIONS ****************************************************************)

(* make index starting from [idx] *)
let make idx = {
 itbl = Hashtbl.create 512;
 vtbl = Hashtbl.create 512;
 idx  = ref idx;
};;

let index idx x = 
 if not (Hashtbl.mem idx.itbl x) then (
  Hashtbl.add idx.itbl x !(idx.idx);
  Hashtbl.add idx.vtbl !(idx.idx) x;
  incr idx.idx;
 );
 Hashtbl.find idx.itbl x
;;

let value idx v = Hashtbl.find idx.vtbl v;;

let values idx = Hashtbl.fold (fun k v acc -> v::acc) idx.vtbl [];;

