(*** OPENS ********************************************************************)
open Formula;;

(*** TYPES ********************************************************************)

(*** FUNCTIONS ****************************************************************)

let solve f = 
 let cnf = Cnf.cnf f in
 Cnf.print_cnf cnf;
 match MiniSat.solve cnf with
  | Some assign -> 
   (* drop variables added by CNF transformation *)
   Some (List.filter (function (P(_),_) -> true | _ -> false) assign)
  | None -> None
 ;;

(*** debug output ****)
let print_kv (P(k),v) = Format.printf "%s%d " (if v then "" else "-") k;;

let print_assign assign =
 if (!Debug.answer || !Debug.model) then Debug.print_time ();
 match assign with 
 | Some assign ->
  if !Debug.answer then Format.printf "@[sat";
  if !Debug.model then (Format.printf "@\n"; List.iter print_kv assign); 
  if !Debug.answer then Format.printf "@]@\n";
 | None -> 
  if !Debug.answer then Format.printf "@[unsat@]@\n";
;;

